# Benchmark for measuring VLArrays
# (mainly for comparing HDF5 1.6.x a 1.8.x speeds)
# See http://hdf-forum.184993.n3.nabble.com/Variable-length-types-slowness-td195101.html#a195101

import random
import tables
from time import time
import numpy as np

print "HDF5 version:      %s" % tables.whichLibVersion("hdf5")[1]

# Create a list of random lists
random.seed(2)  # for reproducible results
ne = [np.arange(random.randint(0,500), dtype='i4') for i in xrange(10000)]

# Create a VLArray
fileh = tables.openFile('/tmp/vlarray.h5', mode='w')
vlarray = fileh.createVLArray(fileh.root, 'vlarray1',
                              tables.Int32Atom(shape=()),
                              "ragged array of ints")

# Fill the VLArray with random length entries
t0 = time()
for l in ne:
    # Append some (variable length) rows:
    vlarray.append(l)
print "time to append--> %.3f" % (time()-t0)

# Close the file.
fileh.close()
